/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Diff of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.10 Revision 1.45
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2014 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.10 2007/03/13 12:02:04 kosmikus Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.45 2014/06/27 07:16:47 slyfox Exp $
4# 4
5# @ECLASS: haskell-cabal.eclass
6# @MAINTAINER:
7# Haskell herd <haskell@gentoo.org>
8# @AUTHOR:
5# Original authors: Andres Loeh <kosmikus@gentoo.org> 9# Original author: Andres Loeh <kosmikus@gentoo.org>
6# Duncan Coutts <dcoutts@gentoo.org> 10# Original author: Duncan Coutts <dcoutts@gentoo.org>
7# Maintained by: Haskell herd <haskell@gentoo.org> 11# @BLURB: for packages that make use of the Haskell Common Architecture for Building Applications and Libraries (cabal)
8# 12# @DESCRIPTION:
9# This eclass is for packages that make use of the
10# Haskell Common Architecture for Building Applications
11# and Libraries (cabal).
12#
13# Basic instructions: 13# Basic instructions:
14# 14#
15# Before inheriting the eclass, set CABAL_FEATURES to 15# Before inheriting the eclass, set CABAL_FEATURES to
16# reflect the tools and features that the package makes 16# reflect the tools and features that the package makes
17# use of. 17# use of.
18# 18#
19# Currently supported features: 19# Currently supported features:
20# haddock -- for documentation generation 20# haddock -- for documentation generation
21# hscolour -- generation of colourised sources
22# hoogle -- generation of documentation search index
21# alex -- lexer/scanner generator 23# alex -- lexer/scanner generator
22# happy -- parser generator 24# happy -- parser generator
23# c2hs -- C interface generator 25# c2hs -- C interface generator
24# cpphs -- C preprocessor clone written in Haskell 26# cpphs -- C preprocessor clone written in Haskell
25# profile -- if package supports to build profiling-enabled libraries 27# profile -- if package supports to build profiling-enabled libraries
26# bootstrap -- only used for the cabal package itself 28# bootstrap -- only used for the cabal package itself
27# bin -- the package installs binaries 29# bin -- the package installs binaries
28# lib -- the package installs libraries 30# lib -- the package installs libraries
29# 31# nocabaldep -- don't add dependency on cabal.
30# Dependencies on other cabal packages have to be specified 32# only used for packages that _must_ not pull the dependency
31# correctly. 33# on cabal, but still use this eclass (e.g. haskell-updater).
32# 34# test-suite -- add support for cabal test-suites (introduced in Cabal-1.8)
33# Cabal libraries should usually be SLOTted with "${PV}".
34#
35# Many Cabal packages require S to be manually set.
36#
37# Conforming Cabal packages don't require any function definitions
38# in the ebuild.
39#
40# Special flags to Cabal Configure can now be set by using
41# CABAL_CONFIGURE_FLAGS
42 35
43inherit ghc-package 36inherit eutils ghc-package multilib multiprocessing
44 37
38# @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
39# @DESCRIPTION:
40# User-specified additional parameters passed to 'setup configure'.
41# example: /etc/portage/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
42: ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
43
44# @ECLASS-VARIABLE: CABAL_EXTRA_BUILD_FLAGS
45# @DESCRIPTION:
46# User-specified additional parameters passed to 'setup build'.
47# example: /etc/portage/make.conf: CABAL_EXTRA_BUILD_FLAGS=-v
48: ${CABAL_EXTRA_BUILD_FLAGS:=}
49
50# @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
51# @DESCRIPTION:
52# User-specified additional parameters for ghc when building
53# _only_ 'setup' binary bootstrap.
54# example: /etc/portage/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
55# linking 'setup' faster.
56: ${GHC_BOOTSTRAP_FLAGS:=}
57
58# @ECLASS-VARIABLE: CABAL_DEBUG_LOOSENING
59# @DESCRIPTION:
60# Show debug output for 'cabal_chdeps' function if set.
61# Needs working 'diff'.
62: ${CABAL_DEBUG_LOOSENING:=}
63
64HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
65
66# 'dev-haskell/cabal' passes those options with ./configure-based
67# configuration, but most packages don't need/don't accept it
68QA_CONFIGURE_OPTIONS+=" --with-hc --with-hc-pkg --with-gcc"
69
70case "${EAPI:-0}" in
71 2|3|4|5) HASKELL_CABAL_EXPF+=" src_configure" ;;
72 *) ;;
73esac
74
75EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
45 76
46for feature in ${CABAL_FEATURES}; do 77for feature in ${CABAL_FEATURES}; do
47 case ${feature} in 78 case ${feature} in
48 haddock) CABAL_USE_HADDOCK=yes;; 79 haddock) CABAL_USE_HADDOCK=yes;;
80 hscolour) CABAL_USE_HSCOLOUR=yes;;
81 hoogle) CABAL_USE_HOOGLE=yes;;
49 alex) CABAL_USE_ALEX=yes;; 82 alex) CABAL_USE_ALEX=yes;;
50 happy) CABAL_USE_HAPPY=yes;; 83 happy) CABAL_USE_HAPPY=yes;;
51 c2hs) CABAL_USE_C2HS=yes;; 84 c2hs) CABAL_USE_C2HS=yes;;
52 cpphs) CABAL_USE_CPPHS=yes;; 85 cpphs) CABAL_USE_CPPHS=yes;;
53 profile) CABAL_USE_PROFILE=yes;; 86 profile) CABAL_USE_PROFILE=yes;;
54 bootstrap) CABAL_BOOTSTRAP=yes;; 87 bootstrap) CABAL_BOOTSTRAP=yes;;
55 bin) CABAL_HAS_BINARIES=yes;; 88 bin) CABAL_HAS_BINARIES=yes;;
56 lib) CABAL_HAS_LIBRARIES=yes;; 89 lib) CABAL_HAS_LIBRARIES=yes;;
90 nocabaldep) CABAL_FROM_GHC=yes;;
91 test-suite) CABAL_TEST_SUITE=yes;;
57 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";; 92 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";;
58 esac 93 esac
59done 94done
60 95
61if [[ -n "${CABAL_USE_HADDOCK}" ]]; then 96if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
62 IUSE="${IUSE} doc" 97 IUSE="${IUSE} doc"
98 # don't require depend on itself to build docs.
99 # ebuild bootstraps docs from just built binary
100 [[ ${CATEGORY}/${PN} = "dev-haskell/haddock" ]] || DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
101fi
102
103if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
104 IUSE="${IUSE} hscolour"
63 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )" 105 DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
64 cabalconf="${cabalconf} --with-haddock=/usr/bin/haddock"
65fi 106fi
66 107
67if [[ -n "${CABAL_USE_ALEX}" ]]; then 108if [[ -n "${CABAL_USE_ALEX}" ]]; then
68 DEPEND="${DEPEND} dev-haskell/alex" 109 DEPEND="${DEPEND} dev-haskell/alex"
69 cabalconf="${cabalconf} --with-alex=/usr/bin/alex"
70fi 110fi
71 111
72if [[ -n "${CABAL_USE_HAPPY}" ]]; then 112if [[ -n "${CABAL_USE_HAPPY}" ]]; then
73 DEPEND="${DEPEND} dev-haskell/happy" 113 DEPEND="${DEPEND} dev-haskell/happy"
74 cabalconf="${cabalconf} --with-happy=/usr/bin/happy"
75fi 114fi
76 115
77if [[ -n "${CABAL_USE_C2HS}" ]]; then 116if [[ -n "${CABAL_USE_C2HS}" ]]; then
78 DEPEND="${DEPEND} dev-haskell/c2hs" 117 DEPEND="${DEPEND} dev-haskell/c2hs"
79 cabalconf="${cabalconf} --with-c2hs=/usr/bin/c2hs"
80fi 118fi
81 119
82if [[ -n "${CABAL_USE_CPPHS}" ]]; then 120if [[ -n "${CABAL_USE_CPPHS}" ]]; then
83 DEPEND="${DEPEND} dev-haskell/cpphs" 121 DEPEND="${DEPEND} dev-haskell/cpphs"
84 cabalconf="${cabalconf} --with-cpphs=/usr/bin/cpphs"
85fi 122fi
86 123
87if [[ -n "${CABAL_USE_PROFILE}" ]]; then 124if [[ -n "${CABAL_USE_PROFILE}" ]]; then
88 IUSE="${IUSE} profile" 125 IUSE="${IUSE} profile"
89fi 126fi
90 127
128if [[ -n "${CABAL_TEST_SUITE}" ]]; then
129 IUSE="${IUSE} test"
130fi
131
91# We always use a standalone version of Cabal, rather than the one that comes 132# We always use a standalone version of Cabal, rather than the one that comes
92# with GHC. But of course we can't depend on cabal when building cabal itself. 133# with GHC. But of course we can't depend on cabal when building cabal itself.
134if [[ -z ${CABAL_MIN_VERSION} ]]; then
135 CABAL_MIN_VERSION=1.1.4
136fi
137if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]]; then
138 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}"
139fi
140
141# returns the version of cabal currently in use
142_CABAL_VERSION_CACHE=""
143cabal-version() {
144 if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then
93if [[ -z "${CABAL_BOOTSTRAP}" ]]; then 145 if [[ "${CABAL_BOOTSTRAP}" ]]; then
94 DEPEND="${DEPEND} >=dev-haskell/cabal-1.1.3" 146 # We're bootstrapping cabal, so the cabal version is the version
147 # of this package itself.
148 _CABAL_VERSION_CACHE="${PV}"
149 elif [[ "${CABAL_FROM_GHC}" ]]; then
150 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
151 # /path/to/ghc/Cabal-${VER} -> ${VER}
152 _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
153 else
154 # We ask portage, not ghc, so that we only pick up
155 # portage-installed cabal versions.
156 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
157 fi
95fi 158 fi
96 159 echo "${_CABAL_VERSION_CACHE}"
97# Libraries require GHC to be installed. 160}
98if [[ -n "${CABAL_HAS_LIBRARIES}" ]]; then
99 RDEPEND="${RDEPEND} virtual/ghc"
100fi
101 161
102cabal-bootstrap() { 162cabal-bootstrap() {
103 local setupmodule 163 local setupmodule
104 local cabalversion 164 local cabalpackage
105 if [[ -f "${S}/Setup.lhs" ]]; then 165 if [[ -f "${S}/Setup.lhs" ]]; then
106 setupmodule="${S}/Setup.lhs" 166 setupmodule="${S}/Setup.lhs"
167 elif [[ -f "${S}/Setup.hs" ]]; then
168 setupmodule="${S}/Setup.hs"
107 else 169 else
108 if [[ -f "${S}/Setup.hs" ]]; then
109 setupmodule="${S}/Setup.hs"
110 else
111 die "No Setup.lhs or Setup.hs found" 170 die "No Setup.lhs or Setup.hs found"
112 fi 171 fi
172
173 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
174 eerror "The package dev-haskell/cabal is not correctly installed for"
175 eerror "the currently active version of ghc ($(ghc-version)). Please"
176 eerror "run haskell-updater or re-build dev-haskell/cabal."
177 die "cabal is not correctly installed"
113 fi 178 fi
114 179
115 # We build the setup program using the latest version of 180 # We build the setup program using the latest version of
116 # cabal that we have installed 181 # cabal that we have installed
117 cabalversion=$(ghc-bestcabalversion) 182 cabalpackage=Cabal-$(cabal-version)
118 einfo "Using ${cabalversion}." 183 einfo "Using cabal-$(cabal-version)."
119 $(ghc-getghc) -package "${cabalversion}" --make "${setupmodule}" -o setup \ 184
185 make_setup() {
186 set -- -package "${cabalpackage}" --make "${setupmodule}" \
187 ${HCFLAGS} \
188 ${GHC_BOOTSTRAP_FLAGS} \
189 "$@" \
190 -o setup
191 echo $(ghc-getghc) "$@"
192 $(ghc-getghc) "$@"
193 }
194 if $(ghc-supports-shared-libraries); then
195 # # some custom build systems might use external libraries,
196 # # for which we don't have shared libs, so keep static fallback
197 # bug #411789, http://hackage.haskell.org/trac/ghc/ticket/5743#comment:3
198 # http://hackage.haskell.org/trac/ghc/ticket/7062
199 # http://hackage.haskell.org/trac/ghc/ticket/3072
200 # ghc does not set RPATH for extralibs, thus we do it ourselves by hands
201 einfo "Prepending $(ghc-libdir) to LD_LIBRARY_PATH"
202 if [[ ${CHOST} != *-darwin* ]]; then
203 LD_LIBRARY_PATH="$(ghc-libdir)${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
204 export LD_LIBRARY_PATH
205 else
206 DYLD_LIBRARY_PATH="$(ghc-libdir)${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
207 export DYLD_LIBRARY_PATH
208 fi
209 { make_setup -dynamic "$@" && ./setup --help >/dev/null; } ||
120 || die "compiling ${setupmodule} failed" 210 make_setup "$@" || die "compiling ${setupmodule} failed"
211 else
212 make_setup "$@" || die "compiling ${setupmodule} failed"
213 fi
214}
215
216cabal-mksetup() {
217 local setupdir=${1:-${S}}
218 local setup_src=${setupdir}/Setup.hs
219
220 rm -vf "${setupdir}"/Setup.{lhs,hs}
221 elog "Creating 'Setup.hs' for 'Simple' build type."
222
223 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
224 > "${setup_src}" || die "failed to create default Setup.hs"
225}
226
227cabal-hscolour() {
228 set -- hscolour "$@"
229 echo ./setup "$@"
230 ./setup "$@" || die "setup hscolour failed"
121} 231}
122 232
123cabal-haddock() { 233cabal-haddock() {
124 ./setup haddock || die "setup haddock failed" 234 set -- haddock "$@"
235 echo ./setup "$@"
236 ./setup "$@" || die "setup haddock failed"
237}
238
239cabal-hscolour-haddock() {
240 # --hyperlink-source implies calling 'setup hscolour'
241 set -- haddock --hyperlink-source
242 echo ./setup "$@"
243 ./setup "$@" --hyperlink-source || die "setup haddock --hyperlink-source failed"
244}
245
246cabal-die-if-nonempty() {
247 local breakage_type=$1
248 shift
249
250 [[ "${#@}" == 0 ]] && return 0
251 eerror "Detected ${breakage_type} packages: ${@}"
252 die "//==-- Please, run 'haskell-updater' to fix ${breakage_type} packages --==//"
253}
254
255cabal-show-brokens() {
256 elog "ghc-pkg check: 'checking for other broken packages:'"
257 # pretty-printer
258 $(ghc-getghcpkg) check 2>&1 \
259 | egrep -v '^Warning: haddock-(html|interfaces): ' \
260 | egrep -v '^Warning: include-dirs: ' \
261 | head -n 20
262
263 cabal-die-if-nonempty 'broken' \
264 $($(ghc-getghcpkg) check --simple-output)
265}
266
267cabal-show-old() {
268 cabal-die-if-nonempty 'outdated' \
269 $("${EPREFIX}"/usr/sbin/haskell-updater --quiet --upgrade --list-only)
270}
271
272cabal-show-brokens-and-die() {
273 cabal-show-brokens
274 cabal-show-old
275
276 die "$@"
125} 277}
126 278
127cabal-configure() { 279cabal-configure() {
280 local cabalconf=()
281 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
282
283 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
284 cabalconf+=(--with-haddock=${EPREFIX}/usr/bin/haddock)
285 fi
128 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then 286 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
129 cabalconf="${cabalconf} --enable-executable-profiling";
130 cabalconf="${cabalconf} --enable-library-profiling" 287 cabalconf+=(--enable-library-profiling)
131 fi 288 fi
289 if [[ -n "${CABAL_USE_ALEX}" ]]; then
290 cabalconf+=(--with-alex=${EPREFIX}/usr/bin/alex)
291 fi
292
293 if [[ -n "${CABAL_USE_HAPPY}" ]]; then
294 cabalconf+=(--with-happy=${EPREFIX}/usr/bin/happy)
295 fi
296
297 if [[ -n "${CABAL_USE_C2HS}" ]]; then
298 cabalconf+=(--with-c2hs=${EPREFIX}/usr/bin/c2hs)
299 fi
300 if [[ -n "${CABAL_USE_CPPHS}" ]]; then
301 cabalconf+=(--with-cpphs=${EPREFIX}/usr/bin/cpphs)
302 fi
303 if [[ -n "${CABAL_TEST_SUITE}" ]]; then
304 cabalconf+=($(use_enable test tests))
305 fi
306
307 local option
308 for option in ${HCFLAGS}
309 do
310 cabalconf+=(--ghc-option="$option")
311 done
312
313 # parallel on all available cores
314 if ghc-supports-parallel-make; then
315 local max_jobs=$(makeopts_jobs)
316
317 # limit to very small value, as parallelism
318 # helps slightly, but makes things severely worse
319 # when amount of threads is Very Large.
320 [[ ${max_jobs} -gt 4 ]] && max_jobs=4
321
322 cabalconf+=(--ghc-option=-j"$max_jobs")
323 fi
324
132 # Building GHCi libs on ppc64 causes "TOC overflow". 325 # Building GHCi libs on ppc64 causes "TOC overflow".
133 if use ppc64; then 326 if use ppc64; then
134 cabalconf="${cabalconf} --disable-library-for-ghci" 327 cabalconf+=(--disable-library-for-ghci)
328 fi
329
330 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
331 # so translate LDFLAGS to ghc parameters (without filtering)
332 local flag
333 for flag in $LDFLAGS; do cabalconf+=(--ghc-option="-optl$flag"); done
334
335 # disable executable stripping for the executables, as portage will
336 # strip by itself, and pre-stripping gives a QA warning.
337 # cabal versions previous to 1.4 does not strip executables, and does
338 # not accept the flag.
339 # this fixes numerous bugs, amongst them;
340 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
341 cabalconf+=(--disable-executable-stripping)
342
343 cabalconf+=(--docdir="${EPREFIX}"/usr/share/doc/${PF})
344 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
345 # it's better if the configure chatter is in the build logs:
346 cabalconf+=(--verbose)
347
348 # We build shared version of our Cabal where ghc ships it's shared
349 # version of it. We will link ./setup as dynamic binary againt Cabal later.
350 [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
351 $(ghc-supports-shared-libraries) && \
352 cabalconf+=(--enable-shared)
353
354 if $(ghc-supports-shared-libraries); then
355 # maybe a bit lower
356 if $(ghc-supports-dynamic-by-default); then
357 cabalconf+=(--enable-shared)
135 fi 358 fi
359 fi
136 360
361 # --sysconfdir appeared in Cabal-1.18+
362 if ./setup configure --help | grep -q -- --sysconfdir; then
363 cabalconf+=(--sysconfdir="${EPREFIX}"/etc)
364 fi
365
366 # appeared in Cabal-1.18+ (see '--disable-executable-stripping')
367 if ./setup configure --help | grep -q -- --disable-library-stripping; then
368 cabalconf+=(--disable-library-stripping)
369 fi
370
137 ./setup configure \ 371 set -- configure \
138 --ghc --prefix=/usr \ 372 --ghc --prefix="${EPREFIX}"/usr \
139 --with-compiler="$(ghc-getghc)" \ 373 --with-compiler="$(ghc-getghc)" \
140 --with-hc-pkg="$(ghc-getghcpkg)" \ 374 --with-hc-pkg="$(ghc-getghcpkg)" \
375 --prefix="${EPREFIX}"/usr \
376 --libdir="${EPREFIX}"/usr/$(get_libdir) \
377 --libsubdir=${P}/ghc-$(ghc-version) \
378 --datadir="${EPREFIX}"/usr/share/ \
379 --datasubdir=${P}/ghc-$(ghc-version) \
141 ${cabalconf} \ 380 "${cabalconf[@]}" \
142 ${CABAL_CONFIGURE_FLAGS} \ 381 ${CABAL_CONFIGURE_FLAGS} \
143 "$@" || die "setup configure failed" 382 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
383 "$@"
384 echo ./setup "$@"
385 ./setup "$@" || cabal-show-brokens-and-die "setup configure failed"
144} 386}
145 387
146cabal-build() { 388cabal-build() {
147 ./setup build \ 389 set -- build ${CABAL_EXTRA_BUILD_FLAGS} "$@"
390 echo ./setup "$@"
391 ./setup "$@" \
148 || die "setup build failed" 392 || die "setup build failed"
149} 393}
150 394
151cabal-copy() { 395cabal-copy() {
152 ./setup copy \ 396 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
153 --copy-prefix="${D}/usr" \ 397
398 set -- copy --destdir="${D}" "$@"
399 echo ./setup "$@"
154 || die "setup copy failed" 400 ./setup "$@" || die "setup copy failed"
155 401
156 # cabal is a bit eager about creating dirs, 402 # cabal is a bit eager about creating dirs,
157 # so remove them if they are empty 403 # so remove them if they are empty
158 rmdir "${D}/usr/bin" 2> /dev/null 404 rmdir "${ED}/usr/bin" 2> /dev/null
159
160 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has
161 # no workaround.
162 # set the +x permission on executables
163 if [[ -d "${D}/usr/bin" ]] ; then
164 chmod +x "${D}/usr/bin/"*
165 fi
166} 405}
167 406
168cabal-pkg() { 407cabal-pkg() {
169 # This does not actually register since we're using true instead 408 # This does not actually register since we're using true instead
170 # of ghc-pkg. So it just leaves the .installed-pkg-config and we can 409 # of ghc-pkg. So it just leaves the .conf file and we can
171 # register that ourselves (if it exists). 410 # register that ourselves (if it exists).
172 local result
173 local err
174 411
175 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then 412 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
176 sed -i "s|$(ghc-getghcpkg)|$(type -P true)|" .setup-config 413 # Newer cabal can generate a package conf for us:
177 ./setup register || die "setup register failed" 414 ./setup register --gen-pkg-config="${T}/${P}.conf"
178 if [[ -f .installed-pkg-config ]]; then 415 ghc-setup-pkg "${T}/${P}.conf"
179 ghc-setup-pkg .installed-pkg-config
180 ghc-install-pkg 416 ghc-install-pkg
181 else
182 die "setup register has not generated a package configuration file"
183 fi 417 fi
184 fi 418}
419
420# Some cabal libs are bundled along with some versions of ghc
421# eg filepath-1.0 comes with ghc-6.6.1
422# by putting CABAL_CORE_LIB_GHC_PV="6.6.1" in an ebuild we are declaring that
423# when building with this version of ghc, the ebuild is a dummy that is it will
424# install no files since the package is already included with ghc.
425# However portage still records the dependency and we can upgrade the package
426# to a later one that's not included with ghc.
427# You can also put a space separated list, eg CABAL_CORE_LIB_GHC_PV="6.6 6.6.1".
428cabal-is-dummy-lib() {
429 for version in ${CABAL_CORE_LIB_GHC_PV[*]}; do
430 [[ "$(ghc-version)" == ${version} ]] && return 0
431 done
432 return 1
185} 433}
186 434
187# exported function: check if cabal is correctly installed for 435# exported function: check if cabal is correctly installed for
188# the currently active ghc (we cannot guarantee this with portage) 436# the currently active ghc (we cannot guarantee this with portage)
189haskell-cabal_pkg_setup() { 437haskell-cabal_pkg_setup() {
190 ghc-package_pkg_setup 438 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
191 if [[ -z "${CABAL_BOOTSTRAP}" ]] && ! ghc-sanecabal "1.1.3"; then 439 [[ ${RDEPEND} == *dev-lang/ghc* ]] || eqawarn "QA Notice: A library does not have runtime dependency on dev-lang/ghc."
192 eerror "The package dev-haskell/cabal is not correctly installed for"
193 eerror "the currently active version of ghc ($(ghc-version)). Please"
194 eerror "run ghc-updater or re-emerge dev-haskell/cabal."
195 die "cabal is not correctly installed"
196 fi 440 fi
197 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then 441 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
198 eerror "QA: Neither bin nor lib are in CABAL_FEATURES." 442 eqawarn "QA Notice: Neither bin nor lib are in CABAL_FEATURES."
199 fi 443 fi
200 if [[ -n "${CABAL_UNKNOWN}" ]]; then 444 if [[ -n "${CABAL_UNKNOWN}" ]]; then
201 ewarn "Unknown entry in CABAL_FEATURES: ${CABAL_UNKNONW}" 445 eqawarn "QA Notice: Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}"
202 fi 446 fi
447 if cabal-is-dummy-lib; then
448 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
449 fi
450}
451
452haskell-cabal_src_configure() {
453 cabal-is-dummy-lib && return
454
455 pushd "${S}" > /dev/null
456
457 cabal-bootstrap
458
459 cabal-configure "$@"
460
461 popd > /dev/null
462}
463
464# exported function: nice alias
465cabal_src_configure() {
466 haskell-cabal_src_configure "$@"
203} 467}
204 468
205# exported function: cabal-style bootstrap configure and compile 469# exported function: cabal-style bootstrap configure and compile
206cabal_src_compile() { 470cabal_src_compile() {
207 cabal-bootstrap 471 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
208 cabal-configure 472 # and forgets to separate src_compile() to src_configure()/src_compile().
473 # Such error leads to default src_configure and we lose all passed flags.
474 if ! has "${EAPI:-0}" 0 1; then
475 local passed_flag
476 for passed_flag in "$@"; do
477 [[ ${passed_flag} == --flags=* ]] && \
478 eqawarn "QA Notice: Cabal option '${passed_flag}' has effect only in src_configure()"
479 done
480 fi
481
482 cabal-is-dummy-lib && return
483
484 has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
209 cabal-build 485 cabal-build
210 486
211 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 487 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
488 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
489 # hscolour and haddock
490 cabal-hscolour-haddock
491 else
492 # just haddock
212 cabal-haddock 493 cabal-haddock
213 fi 494 fi
495 else
496 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
497 # just hscolour
498 cabal-hscolour
499 fi
500 fi
214} 501}
502
215haskell-cabal_src_compile() { 503haskell-cabal_src_compile() {
504 pushd "${S}" > /dev/null
505
216 cabal_src_compile 506 cabal_src_compile "$@"
507
508 popd > /dev/null
509}
510
511haskell-cabal_src_test() {
512 pushd "${S}" > /dev/null
513
514 if cabal-is-dummy-lib; then
515 einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
516 else
517 einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
518 set -- test "$@"
519 echo ./setup "$@"
520 ./setup "$@" || die "cabal test failed"
521 fi
522
523 popd > /dev/null
217} 524}
218 525
219# exported function: cabal-style copy and register 526# exported function: cabal-style copy and register
220cabal_src_install() { 527cabal_src_install() {
528 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
529
530 if ! cabal-is-dummy-lib; then
221 cabal-copy 531 cabal-copy
222 cabal-pkg 532 cabal-pkg
223
224 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
225 dohtml -r dist/doc/html/*
226 fi 533 fi
534
535 # create a dummy local package conf file for haskell-updater
536 # if it does not exist (dummy libraries and binaries w/o libraries)
537 local ghc_confdir_with_prefix="$(ghc-confdir)"
538 # remove EPREFIX
539 dodir ${ghc_confdir_with_prefix#${EPREFIX}}
540 local conf_file="${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
541 [[ -e $conf_file ]] || echo '[]' > "$conf_file" || die
542
543 # make sure installed packages do not destroy ghc's
544 # bundled packages
545 local initial_pkg_db=${ROOT}/$(ghc-libdir)/package.conf.d.initial
546 if [[ -e ${initial_pkg_db} ]]; then
547 local checked_pkg
548 for checked_pkg in $(ghc-listpkg "${conf_file}")
549 do
550 local initial_pkg
551 for initial_pkg in $(ghc-listpkg "${initial_pkg_db}"); do
552 if [[ ${checked_pkg} = ${initial_pkg} ]]; then
553 eerror "Package ${checked_pkg} is shipped with $(ghc-version)."
554 eerror "Ebuild author forgot CABAL_CORE_LIB_GHC_PV entry."
555 eerror "Found in ${initial_pkg_db}."
556 die
557 fi
558 done
559 done
560 fi
227} 561}
562
228haskell-cabal_src_install() { 563haskell-cabal_src_install() {
564 pushd "${S}" > /dev/null
565
229 cabal_src_install 566 cabal_src_install
230}
231 567
232EXPORT_FUNCTIONS pkg_setup src_compile src_install 568 popd > /dev/null
569}
570
571# @FUNCTION: cabal_flag
572# @DESCRIPTION:
573# ebuild.sh:use_enable() taken as base
574#
575# Usage examples:
576#
577# CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
578# leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
579#
580# CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
581# also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
582#
583cabal_flag() {
584 if [[ -z "$1" ]]; then
585 echo "!!! cabal_flag() called without a parameter." >&2
586 echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
587 return 1
588 fi
589
590 local UWORD=${2:-$1}
591
592 if use "$1"; then
593 echo "--flags=${UWORD}"
594 else
595 echo "--flags=-${UWORD}"
596 fi
597
598 return 0
599}
600
601# @FUNCTION: cabal_chdeps
602# @DESCRIPTION:
603# Allows easier patching of $CABAL_FILE (${S}/${PN}.cabal by default)
604# depends
605#
606# Accepts argument list as pairs of substitutions: <from-string> <to-string>...
607#
608# Dies on error.
609#
610# Usage examples:
611#
612# src_prepare() {
613# cabal_chdeps \
614# 'base >= 4.2 && < 4.6' 'base >= 4.2 && < 4.7' \
615# 'containers ==0.4.*' 'containers >= 0.4 && < 0.6'
616#}
617# or
618# src_prepare() {
619# CABAL_FILE=${S}/${MY_PN}.cabal cabal_chdeps \
620# 'base >= 4.2 && < 4.6' 'base >= 4.2 && < 4.7'
621# CABAL_FILE=${S}/${MY_PN}-tools.cabal cabal_chdeps \
622# 'base == 3.*' 'base >= 4.2 && < 4.7'
623#}
624#
625cabal_chdeps() {
626 local cabal_fn=${MY_PN:-${PN}}.cabal
627 local cf=${CABAL_FILE:-${S}/${cabal_fn}}
628 local from_ss # ss - substring
629 local to_ss
630 local orig_c # c - contents
631 local new_c
632
633 [[ -f $cf ]] || die "cabal file '$cf' does not exist"
634
635 orig_c=$(< "$cf")
636
637 while :; do
638 from_pat=$1
639 to_str=$2
640
641 [[ -n ${from_pat} ]] || break
642 [[ -n ${to_str} ]] || die "'${from_str}' does not have 'to' part"
643
644 einfo "CHDEP: '${from_pat}' -> '${to_str}'"
645
646 # escape pattern-like symbols
647 from_pat=${from_pat//\*/\\*}
648 from_pat=${from_pat//\[/\\[}
649
650 new_c=${orig_c//${from_pat}/${to_str}}
651
652 if [[ -n $CABAL_DEBUG_LOOSENING ]]; then
653 echo "${orig_c}" >"${T}/${cf}".pre
654 echo "${new_c}" >"${T}/${cf}".post
655 diff -u "${T}/${cf}".{pre,post}
656 fi
657
658 [[ "${orig_c}" == "${new_c}" ]] && die "no trigger for '${from_pat}'"
659 orig_c=${new_c}
660 shift
661 shift
662 done
663
664 echo "${new_c}" > "$cf" ||
665 die "failed to update"
666}
667
668# @FUNCTION: replace-hcflags
669# @USAGE: <old> <new>
670# @DESCRIPTION:
671# Replace the <old> flag with <new> in HCFLAGS. Accepts shell globs for <old>.
672# The implementation is picked from flag-o-matic.eclass:replace-flags()
673replace-hcflags() {
674 [[ $# != 2 ]] && die "Usage: replace-hcflags <old flag> <new flag>"
675
676 local f new=()
677 for f in ${HCFLAGS} ; do
678 # Note this should work with globs like -O*
679 if [[ ${f} == ${1} ]]; then
680 einfo "HCFLAGS: replacing '${f}' to '${2}'"
681 f=${2}
682 fi
683 new+=( "${f}" )
684 done
685 export HCFLAGS="${new[*]}"
686
687 return 0
688}

Legend:
Removed from v.1.10  
changed lines
  Added in v.1.45

  ViewVC Help
Powered by ViewVC 1.1.20